"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.copyToTheClipboard = copyToTheClipboard;

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at <http://mozilla.org/MPL/2.0/>. */

/**
 * Clipboard function taken from
 * https://searchfox.org/mozilla-central/source/devtools/shared/platform/clipboard.js
 */
function copyToTheClipboard(string) {
  const doCopy = function (e) {
    e.clipboardData.setData("text/plain", string);
    e.preventDefault();
  };

  document.addEventListener("copy", doCopy);
  document.execCommand("copy", false, null);
  document.removeEventListener("copy", doCopy);
}